<?php
/*
  $Id: payza.php,v 1 2010/08/11

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License

*/


  class PAYZA {
    var $code, $title, $description, $enabled;

// class constructor
    function PAYZA() {
      $this->code = 'payza';
      $this->title = MODULE_PAYMENT_PAYZA_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYZA_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYZA_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYZA_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_PAYZA_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_PAYZA_ORDER_STATUS_ID;
      }
      $this->form_action_url = 'https://secure.payza.com/checkout';
    }

// class methods
    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return false;
    }

    function process_button() {
      global $order, $currencies;

      //PAYZA accepted currency
      $alert_cur = array('CAD', 'EUR', 'GBP', 'USD', 'AUD');
      $CUR = $order->info['currency'];
      if (!in_array($CUR,$alert_cur)) {
        $CUR = 'USD';
      }
      
	   //to show complete list of product on PAYZA payment gateway page
	   $total = 0.0;
	   for($i=0;$i<count($order->products);$i++)
		{
			if($i > 0) $postfix = "_".$i; 
			
			//start correction by ilc@20111006
			//this correction was neede for cart having multiple line items 
			//with some items having zero value (free)
			$total += $order->products[$i]['price'] * $order->products[$i]['qty'];
			if($order->products[$i]['price']<=0){
				//PAYZA doesn't allow a zero or negative value of ap_amount
				$order->products[$i]['price'] = 0.0001;
			}
			//end correction by ilc@20111006
			
			$hiddenBox .= tep_draw_hidden_field('ap_itemname'.$postfix, $order->products[$i]['name']) .
			tep_draw_hidden_field('ap_amount'.$postfix, $order->products[$i]['price']) .
			tep_draw_hidden_field('ap_quantity'.$postfix, $order->products[$i]['qty']);
		}
		
		$diff = $total - $order->info['total'];
		$disc = 0.00;
		$addi = 0.00;
		if($diff > 0) $disc = $diff;
		if($diff < 0) $addi = 0.00 - $diff;

		$process_button_string = tep_draw_hidden_field('ap_merchant', MODULE_PAYMENT_PAYZA_ACCOUNT) .
                            //tep_draw_hidden_field('ap_totalamount', number_format(($order->info['total']) * $currencies->currencies[$CUR]['value'], $currencies->currencies[$CUR]['decimal_places'])) .
                            //tep_draw_hidden_field('ap_amount', number_format(($order->info['total']) * $currencies->currencies[$CUR]['value'], $currencies->currencies[$CUR]['decimal_places'])) .
                            tep_draw_hidden_field('ap_currency', $CUR) .
                            tep_draw_hidden_field('ap_purchasetype', 'Item') .
							   
							$hiddenBox .
							   
							//pass shipping information to PAYZA payment gateway by parorrey 2011/03/03
							//pass additionlal charges information to PAYZA payment gateway by ilc@20111006
							//pass discount information to PAYZA payment gateway by ilc@20111006
							tep_draw_hidden_field('ap_shippingcharges', number_format($order->info['shipping_cost'], 2, '.', '')) .
							tep_draw_hidden_field('ap_additionalcharges', number_format($addi, 2, '.', '')) .
							tep_draw_hidden_field('ap_discountamount', number_format($disc, 2, '.', '')) .							   
                            //tep_draw_hidden_field('ap_itemname', MODULE_PAYMENT_PAYZA_PRODUCT_TYPE) .
                            tep_draw_hidden_field('ap_returnurl', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL')) .
                            tep_draw_hidden_field('ap_cancelurl', tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));

      return $process_button_string;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function output_error() {
      return false;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYZA_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PAYZA Module', 'MODULE_PAYMENT_PAYZA_STATUS', 'True', 'Do you want to accept PAYZA payments?', '6', '3', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYZA_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('General product description.', 'MODULE_PAYMENT_PAYZA_PRODUCT_TYPE', '', 'Needed to complete the PAYZA payment process.', '6', '5', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PAYZA Account Number', 'MODULE_PAYMENT_PAYZA_ACCOUNT', 'sales@yourshop.com', 'Your PAYZA account number to which the payment is to be made.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_PAYZA_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

/*    function remove() {
      $keys = '';
      $keys_array = $this->keys();
      for ($i=0; $i<sizeof($keys_array); $i++) {
        $keys .= "'" . $keys_array[$i] . "',";
      }
      $keys = substr($keys, 0, -1);

      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
    }
*/
    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_PAYZA_STATUS', 'MODULE_PAYMENT_PAYZA_SORT_ORDER', 'MODULE_PAYMENT_PAYZA_PRODUCT_TYPE', 'MODULE_PAYMENT_PAYZA_ACCOUNT', 'MODULE_PAYMENT_PAYZA_ORDER_STATUS_ID');
    }
  }
?>
